VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cFind"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


' -------------------------------------------------------------------------------
' >>  Descripcin    :: Mdulo para devolver una coleccin con la lista de urls de los Mp3s
' >>  Autor          :: Luciano Lodola . http://www.recursosvisualbasic.com.ar/
' -------------------------------------------------------------------------------

' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Constantes
' -----------------------------------------------------------------------------------------------------------------------------------------------


Private Const INVALID_HANDLE_VALUE = -1
Private Const MAX_PATH = 260
Private Type FILETIME
    dwLowDateTime  As Long
    dwHighDateTime As Long
End Type
Private Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime   As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime  As FILETIME
    nFileSizeHigh    As Long
    nFileSizeLow     As Long
    dwReserved0      As Long
    dwReserved1      As Long
    cFileName        As String * MAX_PATH
    cAlternate       As String * 14
End Type


Private Const ERROR_SUCCESS           As Long = 0
Private Const URL_ESCAPE_PERCENT      As Long = &H1000          'Convert any occurrence of '%' to 'its escape sequence.
Private Const URL_ESCAPE_SPACES_ONLY As Long = &H4000000        'Replace only spaces with escape sequences. This flag takes precedence 'over URL_ESCAPE_UNSAFE, but does not 'apply to opaque URLs.
Private Const URL_DONT_SIMPLIFY      As Long = &H8000000        'Treat '/./' and '/../' in a URL string as literal characters, not as shorthand for navigation.
Private Const URL_UNESCAPE            As Long = &H10000000      'Unescape any escape sequences that the URLs contain, with two exceptions. The escape sequences for '?' and '#' will not be unescaped. If one of the URL_ESCAPE_XXX flags is also set, the two URLs will unescaped, then combined, then escaped.
Private Const URL_ESCAPE_UNSAFE       As Long = &H20000000      'Replace unsafe values with their escape sequences. This flag applies to all URLs, including opaque URLs.
Private Const URL_PLUGGABLE_PROTOCOL  As Long = &H40000000      'Combine URLs with client-defined pluggable protocols, according to the W3C specification. This flag does not apply to standard protocols such as ftp, http, gopher, and so on. f this flag is set, UrlCombine will not simplify URLs, so there is no need to also set URL_DONT_SIMPLIFY.
Private Const INTERNET_CONNECTION_MODEM_BUSY As Long = &H8
Private Const INTERNET_RAS_INSTALLED As Long = &H10
Private Const INTERNET_CONNECTION_OFFLINE As Long = &H20
Private Const INTERNET_CONNECTION_CONFIGURED As Long = &H40
Private Declare Function UrlCanonicalize Lib "shlwapi" Alias "UrlCanonicalizeA" (ByVal pszURL As String, ByVal pszCanonicalized As String, pcchCanonicalized As Long, ByVal dwFlags As Long) As Long

Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFilename As String, lpFindFileData As WIN32_FIND_DATA) As Long


' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Enums - Types
' -----------------------------------------------------------------------------------------------------------------------------------------------


Enum eMp3Directory
    [mp3Realm] = 0
    [playList] = 1
    [mp3000] = 2
End Enum

Enum eSearch
    eTitle = 0
    eKeyWord = 1
End Enum

' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Apis
' -----------------------------------------------------------------------------------------------------------------------------------------------

'Declaracin del Api GetFileTitle
Private Declare Function GetFileTitle Lib "comdlg32.dll" Alias "GetFileTitleA" (ByVal lpszFile As String, ByVal lpszTitle As String, ByVal cbBuf As Integer) As Integer
Private Declare Function PathIsDirectory Lib "shlwapi.dll" Alias "PathIsDirectoryA" (ByVal pszPath As String) As Long
Private Declare Function InternetGetConnectedState Lib "wininet.dll" (ByRef lpdwFlags As Long, ByVal dwReserved As Long) As Long
Private Declare Function URLDownloadToFile Lib "urlmon" Alias "URLDownloadToFileA" (ByVal pCaller As Long, ByVal szURL As String, ByVal szFileName As String, ByVal dwReserved As Long, ByVal lpfnCB As Long) As Long ' funcin para descargar un archivo desde internet al disco
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Vars
' -----------------------------------------------------------------------------------------------------------------------------------------------


Private mColItems                                           As New Collection
Private mTempPath                                           As String
Private mIDsesion                                           As String
Private mMp3Directory                                       As eMp3Directory
Private mDownloadFolder                                     As String
Private mHtmlPath                                           As String

' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Eventos
' -----------------------------------------------------------------------------------------------------------------------------------------------

Event StartSearchMp3s(ByVal sUrl As String)
Event EndGetUrlsMp3()


' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Ruta Html del directorio
' -----------------------------------------------------------------------------------------------------------------------------------------------
Property Get HtmlPath() As String
    HtmlPath = mHtmlPath
End Property

Property Let HtmlPath(sValue As String)
    mHtmlPath = sValue
End Property

' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Descargar archivo de internet de modo sincronizado
' -----------------------------------------------------------------------------------------------------------------------------------------------

Private Function mDownloadFileSync(sUrl As String, sNewFileName As String) As Boolean
    Dim sPath As String
    Screen.MousePointer = vbHourglass
    DoEvents
    mDownloadFileSync = Not URLDownloadToFile(0, sUrl, sNewFileName, 0, 0)
    Screen.MousePointer = vbDefault
End Function


' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Comenzar bsqueda - Preparar la url principal con los archivos Mp3
' -----------------------------------------------------------------------------------------------------------------------------------------------

Sub FindMp3(sValue As String, lDirectory As eMp3Directory, Optional iPage As Integer = -1)

    If Trim(sValue) = "" Then
        Exit Sub
    End If
    
    mIDsesion = ""
    mMp3Directory = lDirectory
    
    While InStr(sValue, "  ")
       sValue = Replace(sValue, "  ", " ")
    Wend
    
    Dim arrValues() As String
    arrValues = Split(sValue, " ")
    
    Dim sCharConc As String
    
    ' Guardar Caracter de concatenacin de las palabras claves para la bsqueda
    If mMp3Directory = mp3Realm Then sCharConc = "+"
    If mMp3Directory = mp3000 Then sCharConc = "_"
    If mMp3Directory = playList Then sCharConc = "%20"
    
    ' separar las palabras
    sValue = ""
    Dim i  As Integer
    For i = 0 To UBound(arrValues)
        sValue = sValue & Trim(arrValues(i)) & sCharConc
    Next
    
    ' Eliminar el ltimo operador de concatenacin
    If mMp3Directory <> playList Then
        If Right(sValue, 1) = sCharConc Then sValue = Left(sValue, Len(sValue) - 1)
    Else
        If Right(sValue, 3) = sCharConc Then sValue = Left(sValue, Len(sValue) - 3)
    End If
    
    
    ' Armar la Url
    Dim sUrl  As String
    If iPage = -1 Then iPage = 1
    
    If mMp3Directory = mp3Realm Then sUrl = "http://mp3realm.org/search?q=" & sValue & "&pp=50&dur=180" & "&page=" & CStr(iPage)
    If mMp3Directory = mp3000 Then sUrl = "http://www.mp3000.net/mp3_" & CStr(iPage - 1) & "/" + sValue
    If mMp3Directory = playList Then sUrl = "http://search.playlist.com/tracks/" & sValue & "/" & CStr(iPage)
    
    ' Enviar evento para que el UC comience a descargar la pgina - Despus vuelve a GetUrlsMp3 para buscar las url en el cdigo fuente
    RaiseEvent StartSearchMp3s(sUrl)
    
    
    
End Sub


' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Sub que vuelca el array de urls en la coleccin
' -----------------------------------------------------------------------------------------------------------------------------------------------

Sub GetUrlsMp3(url_Path As String)
    
   On Error GoTo error_Handler
        
   ' Obtener el cdigo fuente
   Dim sHtml As String
   sHtml = mGetHtml(url_Path)
   
   Dim i                        As Long
   Dim J                        As Long
   Dim sTitle                   As String
   Dim sUrl                     As String
   Dim mArrUrlList()            As String
   
   
   ReDim mArrUrlList(0)
   Set mColItems = Nothing
   
   ' Obtener el array de Urls
   mArrUrlList = mGetUrls(sHtml, mMp3Directory)
   
   ' Recorrer el array y aadir cada una en un nuevo item de la coleccin
   If UBound(mArrUrlList) > 0 Then
        For i = 0 To UBound(mArrUrlList)
            sUrl = mGetUrl(mArrUrlList(i))
            If Len(sUrl) Then
                Dim mValues As New cFindItem
                ' Estableer los campos ( Url, nombre del archivo, ruta local )
                With mValues
                    .Url = sUrl
                    .Key = sUrl
                    .Title = mGetFilePathExt(sUrl, "/")
                    .FileName = mDownloadFolder & mGetFilePathExt(sUrl, "/")
                    
                    ' agregarlos
                    Call mColItems.Add(mValues, sUrl)
                    Set mValues = Nothing
                End With
            End If
        Next
    End If
        
    DoEvents
    ' Enviar evento al frm para que los cargue en el Lv
    RaiseEvent EndGetUrlsMp3
    
Exit Sub
error_Handler:
If Err.Number = 457 Then
   Resume Next
   MsgBox Err.Description
Else
    If App.LogMode = 0 Then
       MsgBox Err.Description, vbCritical, "Funcin GetUrlsMp3 - Error"
    Else
        Err.Raise Err.Number, "GetUrlsMp3", Err.Description
    End If
End If
End Sub


' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - DEvolver la Url
' -----------------------------------------------------------------------------------------------------------------------------------------------

Private Function mGetUrl(ByVal sValue As String) As String
    
    Dim sExt                    As String
    Dim lPos1                   As Long
    Dim lPos2                   As Long
    Dim i                       As Long
    
    Select Case mMp3Directory
        ' http://mp3realm.org/
        ' -------------------------------------------------------------------------------
        Case mp3Realm
            Dim sPlayStream As String
            sPlayStream = LCase("HREF=" & Chr(34) & "javascript:void(0)" & Chr(34) & " onClick=" & Chr(34) & "Play(")
            lPos1 = InStr(lPos1 + 1, LCase(sValue), sPlayStream)
            lPos2 = InStr(lPos1 + Len(sPlayStream), LCase(sValue), "',")
    
            If lPos1 > 0 And lPos2 > 0 Then
                sValue = Mid(sValue, lPos1 + Len(sPlayStream) + 1, lPos2 - (lPos1 + Len(sPlayStream) + 1))
                sValue = Replace(sValue, "\", vbNullString)
                sValue = mEncodeUrlCanonicalize(sValue, URL_UNESCAPE)
                sValue = Replace(sValue, "%20", " ")
                mGetUrl = sValue
            End If
            
        ' http://www.mp3000.net/
        ' -------------------------------------------------------------------------------
        Case mp3000
            Dim s1              As String
            Dim J               As Integer
            Dim sCode           As String
            Dim sFileName       As String
            
            lPos1 = InStr(lPos1 + 1, LCase(sValue), "/download/mp3/")
            If lPos1 = 0 Then
                Exit Function
            Else
                lPos1 = lPos1 + Len("/download/mp3/")
            End If
                For J = lPos1 To Len(sValue)
                    Dim sNum As Integer
                    If Mid(sValue, J, 1) <> "/" Then
                        sCode = sCode & Mid(sValue, J, 1)
                    Else
                        Exit For
                    End If
                Next
            
                If Len(sCode) = 0 Then Exit Function
            
                lPos1 = J
                For J = lPos1 To Len(sValue)
                    If Mid(sValue, J, 8) <> "-mp3.php" Then
                        sFileName = sFileName & Mid(sValue, J, 1)
                    Else
                        sFileName = sFileName & ".mp3"
                        Exit For
                    End If
                Next
            
                If mIDsesion = vbNullString Then
                    Dim ret As Boolean
                    ret = mDownloadFileSync("http://www.mp3000.net/download/mp3/" & sCode & sFileName & ".php", TempPath & "mp3000-sesion.dat")
                
                    If ret Then
                        Dim sHtml As String
                        sHtml = mGetHtml(TempPath & "mp3000-sesion.dat")
            
                        lPos1 = InStr(sHtml, "window.open('/report_br.php?sess=") + Len("window.open('/report_br.php?sess=")
                        lPos2 = InStr(sHtml, "&sid=")
            
                        mIDsesion = Mid(sHtml, lPos1, lPos2 - lPos1)
                    End If
                End If
            
                mGetUrl = "http://www.mp3000.net/redirect/" & sCode & "/" & mIDsesion & sFileName
                
        'http://www.playlist.com/
        '------------------------------------------------------------------------------------
        Case playList
            
            'MsgBox sValue
            sExt = mGetFilePathExt(sValue, ".")
            
            If LCase(sExt) = "mp3" Then
                lPos1 = InStr(lPos1 + 1, LCase(sValue), "originallink=")
                lPos2 = InStr(lPos1 + Len("originallink="), LCase(sValue), ".mp3")
                'sTempUrl = Mid(sValue, lPos1 + Len("originallink="), lPos2 - (lPos1 + Len("originallink=") - Len(".mp3")))
                sValue = Mid(sValue, lPos1 + Len("originallink="), Len(sValue) - lPos1)
                sValue = mEncodeUrlCanonicalize(sValue, URL_UNESCAPE)
                sValue = Replace(sValue, "%20", " ")
                mGetUrl = sValue
            End If
            
    End Select
    
End Function

' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Funcin para convertir los caracteres de secuencia de escape de la direccin
' -----------------------------------------------------------------------------------------------------------------------------------------------

Private Function mEncodeUrlCanonicalize(ByVal sUrl As String, dwFlags As Long) As String
   Dim sUrlEsc As String
   Dim dwSize As Long
   If Len(sUrl) > 0 Then
      sUrlEsc = Space$(MAX_PATH)
      dwSize = Len(sUrlEsc)
      If UrlCanonicalize(sUrl, sUrlEsc, dwSize, dwFlags) = ERROR_SUCCESS Then
         mEncodeUrlCanonicalize = Left$(sUrlEsc, dwSize)
      End If
   End If
End Function


' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Devolver todo el contenido Html
' -----------------------------------------------------------------------------------------------------------------------------------------------

Private Function mGetHtml(ByVal sPath As String) As String
   
   On Error GoTo error_Handler
   
   Dim sTempHtml        As String
   Dim iFreeFile        As Integer
   
   iFreeFile = FreeFile
   
   Open sPath For Input As iFreeFile
   
   sTempHtml = Input$(LOF(iFreeFile), #iFreeFile)
   sTempHtml = Replace(sTempHtml, "&amp;", "")
   mGetHtml = sTempHtml
   
   Close iFreeFile
   
   Exit Function
error_Handler:
   MsgBox Err.Description, vbCritical, "Error en mGetHtml "
End Function

' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Devuelve un array con urls, y en el mp3Realm devuelve la seccin de cada item de la tabla para luego extraer las urls
' -----------------------------------------------------------------------------------------------------------------------------------------------

Private Function mGetUrls(sHtmlCode As String, lDirectMP3 As eMp3Directory) As String()
    
   On Error GoTo error_Handler
    
   Dim arrContent()        As String
   Dim arrUrls()           As String
   
   ReDim arrUrls(0)
    
   Select Case lDirectMP3
        Case mp3Realm
            Dim sPlayStream         As String
            Dim i                   As Integer
            Dim lIndex              As Integer
        
            sPlayStream = "HREF=" & Chr(34) & "javascript:void(0)" & Chr(34) & " onClick=" & Chr(34) & "Play('"
            arrContent = Split(sHtmlCode, "<li>")
            For i = 0 To UBound(arrContent)
                If InStr(LCase(arrContent(i)), LCase(sPlayStream)) > 0 Then
                    ReDim Preserve arrUrls(lIndex)
                    arrUrls(lIndex) = arrContent(i)
                    lIndex = lIndex + 1
                End If
            Next
        
            mGetUrls = arrUrls
        Case mp3000
            arrContent = Split(sHtmlCode, "</tr>")
            For i = 0 To UBound(arrContent)
                If InStr(LCase(arrContent(i)), LCase("mp3.php")) > 0 Then
                    ReDim Preserve arrUrls(lIndex)
                    arrUrls(lIndex) = arrContent(i)
                    lIndex = lIndex + 1
                End If
            Next
            
        Case playList
            Dim o_RegExp            As Object
            Dim o_Match             As Object
            Dim o_Matches           As Object
   
            Set o_RegExp = CreateObject("VBScript.RegExp")
            With o_RegExp
                .IgnoreCase = True
                .Global = True
                .Pattern = "(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?" & Chr(34)
            End With
   
            ' Buscar
            Set o_Matches = o_RegExp.Execute(sHtmlCode)
   
            ' Agregar la lista al array
            For Each o_Match In o_Matches
                arrUrls(UBound(arrUrls)) = Replace(o_Match.Value, Chr(34), vbNullString)
                ReDim Preserve arrUrls(UBound(arrUrls) + 1)
            Next
            Set o_Matches = Nothing
            Set o_Match = Nothing
            Set o_RegExp = Nothing
    End Select
        
    mGetUrls = arrUrls
        
   Exit Function
error_Handler:
   If App.LogMode = 0 Then MsgBox Err.Description, vbCritical, "Error " & CStr(Err.Number)
End Function

' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Eliminar archivos
' -----------------------------------------------------------------------------------------------------------------------------------------------

Private Sub DeleteFiles(sPathDir As String, sFilter As String)
   On Error GoTo error_Handler
   Dim sFileName As String
   
   sFileName = Dir(sPathDir & sFilter)
   If Right(sPathDir, 1) <> "\" Then sPathDir = sPathDir & "\"
   While sFileName <> ""
      Kill sPathDir & sFileName
      sFileName = Dir
   Wend
   Exit Sub
error_Handler:
End Sub

' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Devolver el nombre del mp3 desde la Url
' -----------------------------------------------------------------------------------------------------------------------------------------------

Private Function mGetFilePathExt(sPath As String, sChar As String) As String
    If (Len(sPath)) >= (InStrRev(sPath, sChar)) Then
        mGetFilePathExt = Right(sPath, Len(sPath) - InStrRev(sPath, sChar))
    End If
End Function

Function FileOpen(hwndOwner As Long, sPath As String)
    ShellExecute hwndOwner, vbNullString, sPath, vbNullString, vbNullString, 1
End Function

' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Ruta de la carpeta temporal
' -----------------------------------------------------------------------------------------------------------------------------------------------

Public Property Get TempPath() As String
    TempPath = mTempPath
End Property

Public Property Let TempPath(Value As String)
    On Error GoTo error_Handler
    
    If Right(Value, 1) <> "\" Then Value = Value & "\"
    mTempPath = Value
    If Not Me.CheckFileExists(Value) Then MkDir Value
    
    Exit Property
error_Handler:
    MsgBox Err.Description, vbCritical
End Property

' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Agregar un item a la coleccin
' -----------------------------------------------------------------------------------------------------------------------------------------------

Public Function Add(sTitle As String, sFileName As String, sUrl As String, sKey As String) As cFindItem
    On Error GoTo err_handler
    
    Dim mItem As New cFindItem
    
    With mItem
        .Title = sTitle
        .FileName = sFileName
        .Url = sUrl
        .Key = sKey
        mColItems.Add mItem, sKey
    End With
    
    Set Add = mItem
Exit Function
err_handler:
MsgBox Err.Description

End Function

Function CheckConnection() As Boolean
    CheckConnection = InternetGetConnectedState(0&, 0&)
End Function

' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Devolver la cantidad de items de la coleccin
' -----------------------------------------------------------------------------------------------------------------------------------------------

Property Get Count() As Long
    Count = mColItems.Count

Exit Property
err_handler:
MsgBox Err.Description
End Property

' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Elimnar todos
' -----------------------------------------------------------------------------------------------------------------------------------------------

Public Sub DeleteAll()
On Error GoTo err_handler

    Do Until mColItems.Count = 0
        Delete 1
    Loop
    
Exit Sub
err_handler:
MsgBox Err.Description
    
End Sub

' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Elimnar un item por la clave o por el indice
' -----------------------------------------------------------------------------------------------------------------------------------------------


Public Sub Delete(ByVal Index As Variant)
On Error GoTo err_handler
    
    mColItems.Remove Index

Exit Sub
err_handler:
If Err.Number <> 5 Then
    MsgBox "Error en: DeleteItem - CFind: Descripcin: " & Err.Description
End If
End Sub


Function CheckItemExist(sKey As String) As Boolean
    On Error Resume Next
    Dim xItem As cDownloadItem
    Set xItem = mColItems(sKey)
    If xItem Is Nothing Then
        CheckItemExist = False
    Else
        CheckItemExist = True
    End If
End Function

Property Get item(ByVal Index As Variant) As cFindItem
Attribute item.VB_UserMemId = 0
On Error GoTo err_handler

    Set item = mColItems.item(Index)
    
Exit Property
err_handler:

If Err.Number = 5 Then
    Set item = Nothing
Else
    If App.LogMode = 0 Then
        MsgBox Err.Description
    Else
        Err.Raise Err.Number, "Item - cFind", Err.Description
    End If
End If

End Property

' -----------------------------------------------------------------------------------------------------------------------------------------------
' \\ - Path de la carpeta temporal
' -----------------------------------------------------------------------------------------------------------------------------------------------

Property Get DownloadFolder() As String
    DownloadFolder = mDownloadFolder
End Property

Property Let DownloadFolder(sValue As String)
    
    
    If Right(sValue, 1) <> "\" Then
       sValue = sValue & "\"
    End If
    mDownloadFolder = sValue
    
    If PathIsDirectory(sValue) = 0 Then
       MkDir sValue
    End If
    
    Exit Property
error_Handler:
    If Err.Number <> 75 Then
        MsgBox Err.Description, vbCritical
    End If
End Property

Function GetFileNameTitle(sFileName As String) As String

    Dim sBuffer As String
    sBuffer = String(255, 0)
    MsgBox GetFileTitle(sFileName, sBuffer, Len(sBuffer))
    GetFileNameTitle = Left$(sBuffer, InStr(1, sBuffer, Chr$(0)) - 1)
    
End Function

' ----------------------------------------------------------------------------------------
' Retorna Verdadero si el archivo existe
' ----------------------------------------------------------------------------------------
Public Function CheckFileExists(ByVal strFile As String) As Boolean

    Dim lHandle As Long
    Dim wFD As WIN32_FIND_DATA
    If ((Len(strFile) > 3) And (Right$(strFile, 1) = "\")) Then
        strFile = Left$(strFile, Len(strFile) - 1)
    End If
    
    lHandle = FindFirstFile(strFile, wFD)
    CheckFileExists = lHandle <> INVALID_HANDLE_VALUE
    Call FindClose(lHandle)
    
End Function


Private Sub Class_Terminate()
    Set mColItems = Nothing
End Sub
